package org.jvnet.jaxbcommons.locator.util;

import org.jvnet.jaxbcommons.locator.FieldObjectLocator;
import org.jvnet.jaxbcommons.locator.ListEntryObjectLocator;
import org.jvnet.jaxbcommons.locator.ObjectLocator;
import org.xml.sax.Locator;

public class LocatorUtils {

	private LocatorUtils() {

	}

	public static String getLocation(Locator locator) {
		if (locator == null) {
			return "<unknown>";
		} else {
			return locator.getPublicId() + ":" + locator.getSystemId() + ":"
					+ locator.getLineNumber() + ":" + locator.getColumnNumber();
		}
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, Object value) {
		return locator == null ? null : locator.property(name, value);
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, boolean value) {
		return locator == null ? null : locator.property(name,
				Boolean.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, byte value) {
		return locator == null ? null : locator.property(name,
				Byte.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, char value) {
		return locator == null ? null : locator.property(name,
				Character.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, double value) {
		return locator == null ? null : locator.property(name,
				Double.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, float value) {
		return locator == null ? null : locator.property(name,
				Float.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, int value) {
		return locator == null ? null : locator.property(name,
				Integer.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, long value) {
		return locator == null ? null : locator.property(name,
				Long.valueOf(value));
	}

	public static FieldObjectLocator property(ObjectLocator locator,
			String name, short value) {
		return locator == null ? null : locator.property(name,
				Short.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			Object value) {
		return locator == null ? null : locator.item(index, value);
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			boolean value) {
		return locator == null ? null : locator.item(index,
				Boolean.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			byte value) {
		return locator == null ? null : locator
				.item(index, Byte.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			char value) {
		return locator == null ? null : locator.item(index,
				Character.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			double value) {
		return locator == null ? null : locator.item(index,
				Double.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			float value) {
		return locator == null ? null : locator.item(index,
				Float.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			int value) {
		return locator == null ? null : locator.item(index,
				Integer.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			long value) {
		return locator == null ? null : locator
				.item(index, Long.valueOf(value));
	}

	public static ListEntryObjectLocator item(ObjectLocator locator, int index,
			short value) {
		return locator == null ? null : locator.item(index,
				Short.valueOf(value));
	}

}
